#!/usr/local/bin/perl
## rcsbbs.cgi
## Copyright(C) rin (http://rohuu.s59.xrea.com/) 2004-2008
## Last modified 2008/04/28 10:03:31 +09:00
## Core program

#######################################
#   RCS-BOARD Ver-3.1.3 (2008/04/28)
#   Copyright(C) rin (rohuu)
#   http://rohuu.s59.xrea.com/
#######################################

#use strict;
#use vars qw(%GLOBAL %INI %in %COOK);

$GLOBAL{'product_name'}  = 'RCS-BOARD';
$GLOBAL{'version'}       = '3.1.3';
$GLOBAL{'release_date'}  = '2008/04/28';
$GLOBAL{'product_hp'}    = 'http://rohuu.s59.xrea.com/';
$GLOBAL{'internal_name'} = 'rcsbbs';

&initial();
&main();
&ex_exit();


##------------------------------------------
## Initial routine
##------------------------------------------
sub initial{
	if($^O ne 'MSWin32'){
		$SIG{'HUP'} = $SIG{'INT'} = $SIG{'PIPE'} = $SIG{'QUIT'} = $SIG{'TERM'} = sub{
			&error('Abnormal termination: File->'.(caller(1))[1].' , Line->'.(caller(1))[2], 'DEBUG');
		};
		$SIG{'ALRM'} = sub{
			&error('Time out: File->'.(caller(1))[1].' , Line->'.(caller(1))[2], 'DEBUG');
		};
		eval{alarm 5};
	}
	$| = 0;
	$GLOBAL{'flag'} = {};
	($GLOBAL{'scr_name'} = $0) =~ s|.*[/\\]([^/\\]+)$|$1|;
	($GLOBAL{'bbs_id'} = $GLOBAL{'scr_name'}) =~ s/^([^\.]+)\.\w+$/$1/;
	if(!$GLOBAL{'ini_file'}){$GLOBAL{'ini_file'} = './rcsini.cgi';}
	$GLOBAL{'charcode'} = {
		'utf8'        => 'UTF-8',
		'sjis'        => 'Shift_JIS',
		'euc'         => 'EUC-JP',
		'jis'         => 'ISO-2022-JP',
		'ucs2'        => 'UTF-16BE',
	};

	if(!do "$GLOBAL{'ini_file'}"){&error($@ ? $@ : "Ini file: $!", 'DEBUG');}
	else{
		$GLOBAL{'flag'}{'ini_load'} = 1;
		if($INI{'scr_name'}){$GLOBAL{'scr_name'} = $INI{'scr_name'};}
		if($INI{'oneman_mode'}){$INI{'scr_b'} = '.';}
		if($INI{'bbs_id'} ne ''){$GLOBAL{'bbs_id'} = $INI{'bbs_id'};}
	}
	if(!do "$INI{'skin_file'}"){&error($@ ? $@ : "Skin file: $!", 'DEBUG');}
	else{$GLOBAL{'flag'}{'skin_load'} = 1;}
	&decode();
	&get_cook();
	($GLOBAL{'browser'}, $GLOBAL{'browser_ver'}, $GLOBAL{'browser_ver_testoption'}) = &get_browser();
	&access_deny();

	## Can use JavaScript Full-Mode?
	if(
		(($GLOBAL{'browser'} eq 'Gecko'  && $GLOBAL{'browser_ver'} >= 0.009) ||
		($GLOBAL{'browser'}  eq 'Opera'  && $GLOBAL{'browser_ver'} >= 7) ||
		($GLOBAL{'browser'}  eq 'WebKit' && $GLOBAL{'browser_ver'} >= 0) ||
		($GLOBAL{'browser'}  eq 'KHTML'  && $GLOBAL{'browser_ver'} >= 3) ||
		($GLOBAL{'browser'}  eq 'IE'     && $GLOBAL{'browser_ver'} >= 5)) &&
		$INI{'js_full_mode'}
	){
		$GLOBAL{'js_full_mode'} = 1;
	}
	else{$GLOBAL{'js_full_mode'} = 0;}

	## Can use Ajax?
	if(
		(($GLOBAL{'browser'} eq 'Gecko'  && $GLOBAL{'browser_ver'} >= 0.009007) ||
		($GLOBAL{'browser'}  eq 'Opera'  && $GLOBAL{'browser_ver'} >= 8) ||
		($GLOBAL{'browser'}  eq 'WebKit' && $GLOBAL{'browser_ver'} >= 125) ||  ## Safari 1.2
		($GLOBAL{'browser'}  eq 'KHTML'  && $GLOBAL{'browser_ver'} >= 3.003) ||
		($GLOBAL{'browser'}  eq 'IE'     && $GLOBAL{'browser_ver'} >= 5)) &&
		$GLOBAL{'js_full_mode'}
	){
		$GLOBAL{'ajax_usable'} = 1;
	}
	else{$GLOBAL{'ajax_usable'} = 0;}

	## Can use visitor list? Disable Opera, KHTML (and WebKit?), because doesn't function "unload".
	if(
		!$INI{'disp_visitor'} || !$GLOBAL{'ajax_usable'} ||
		$GLOBAL{'browser'} eq 'Opera' || $GLOBAL{'browser'} eq 'KHTML' || $GLOBAL{'browser'} eq 'WebKit'
#		($GLOBAL{'browser'} eq 'WebKit' && $GLOBAL{'browser_ver'} < 420)
	){
		$GLOBAL{'visitorlist_usable'} = 0;
	}
	else{$GLOBAL{'visitorlist_usable'} = 1;}

	return 1;
}


##------------------------------------------
## Decode request data
##------------------------------------------
sub decode{
	my($referer, $buffer, $name, $value, @del_num_list);

	if($ENV{'REQUEST_METHOD'} eq 'POST'){
		if($INI{'referer_uri'}){
			($referer = $INI{'referer_uri'}) =~ s/\./\\\./g;
			if($ENV{'HTTP_REFERER'} !~ /^(?:$referer)/){&error((&skin_message())[14]);}
		}
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}
	else{$buffer = $ENV{'QUERY_STRING'};}

	foreach(split(/&/, $buffer)){
		($name, $value) = split(/=/);
		$value =~ tr/+/ /;
		$value =~ s/%([\da-fA-F]{2})/chr hex($1)/ge;
		if($name =~ /_text$/){
			$value = &char_convert($value, $INI{'internal_code'}, $INI{'code'} =~ /UTF|ucs/i ? 'UTF-8' : $INI{'code'});
		}
		elsif($name =~ /_itext$/){
			$value = &char_convert($value, $INI{'internal_code'}, $INI{'icode'} =~ /UTF|ucs/i ? 'UTF-8' : $INI{'icode'});
		}
		$value = &remove_xss($value);
		$value =~ s/[\t\n\r]//g;
		if($name =~ /_list$/){push(@{$in{$name}}, $value);}
		else{$in{$name} = $value;}
	}
	return 1;
}


##------------------------------------------
## Main routine
##------------------------------------------
sub main{
	if($in{'mode'} eq 'top'){&news($INI{'top_news'});}
	elsif($in{'mode'} eq 'option'){&option();}
	elsif($in{'mode'} eq 'regist'){
		&regist($COOK{'name'}, $COOK{'color'}, $in{'com_text'}, 0);
		&news($INI{'top_news'});
	}
	elsif($in{'mode'} eq 'log'){&news($INI{'log_news'});}
	elsif($in{'mode'} eq 'help'){&help();}
	elsif($in{'mode'} eq 'renew'){&modify_visitor('renew', $in{'id'});}
	elsif($in{'mode'} eq 'logout'){&modify_visitor('remove', $in{'id'});}
	elsif($in{'mode'} eq 'admin'){&admin();}
	else{&frame();}
	return 1;
}


##------------------------------------------
## Output frame
##------------------------------------------
sub frame{
	my(%dd, $output);

	if($COOK{'id'} ne ''){
		$GLOBAL{'set_cook'} = &set_cook(
			$COOK{'name'},
			$COOK{'color'},
			$COOK{'stealth'},
			$COOK{'jsmode'},
			$COOK{'sckeydata'},
			$COOK{'news_sort'},
			$COOK{'disp_time'},
			$COOK{'indv'}
		);
	}
	if($COOK{'id'} ne '' && !$COOK{'stealth'}){&modify_visitor('add', $COOK{'id'}, $COOK{'name'});}
	else{&modify_visitor('clean');}

	if($INI{'interval'} && (gmtime(time + $INI{'TZ'}))[3] ne (gmtime((stat($INI{'log_file'}))[9] + $INI{'TZ'}))[3]){
		unlink <$INI{'tmp_dir'}/*.tmp>;
	}
	if($COOK{'name'} eq ''){$dd{'name'} = $INI{'no_name_frame'};}
	else{
		$dd{'name'} = length(&remove_xss($COOK{'name'}, 1)) > $INI{'len_p_name'} ?
		              substr($COOK{'name'}, 0, $INI{'len_p_name'} - 2).'...' : $COOK{'name'};
	}
	$dd{'bbs_id'} = "$GLOBAL{'bbs_id'}js";

	if(!$INI{'oneman_mode'}){
		$dd{'tmp_dir'} = $INI{'tmp_dir'} !~ /^http:\/\// ? "$INI{'scr_b'}/$INI{'tmp_dir'}" : $INI{'tmp_dir'};
		$dd{'outframe'} = '<style type="text/css"><!--'.&skin_css().'--></style>'.&skin_frame(\%dd);
		$dd{'outframe'} =~ s/'/\\'/g;  $dd{'outframe'} =~ s/\r//g;  $dd{'outframe'} =~ s/\n/'+\n'/g;
		do "$INI{'js_file'}" or &error($@ ? $@ : "Javascript file: $!", 'DEBUG');
		$output = $GLOBAL{'js_full_mode'} && $COOK{'jsmode'} ? &js_full(\%dd) : &js_lite(\%dd);
		$output =~ s/\/\*.*\*\/|\t//g;
		$output =~ s/ {2,}/ /g;
		$output =~ s/\n{2,}/\n/g;
		&output_http_header($INI{'camouflage_contenttype'}, $INI{'code'});
	}
	else{
		$dd{'tmp_dir'} = $INI{'tmp_dir'};
		$dd{'code'} = $GLOBAL{'charcode'}{$INI{'icode'}} ? $GLOBAL{'charcode'}{$INI{'icode'}} : $INI{'icode'};
		do "$INI{'js_file'}" or &error($@ ? $@ : "Javascript file: $!", 'DEBUG');
		$dd{'jscode'} = $GLOBAL{'js_full_mode'} && $COOK{'jsmode'} ? &js_full(\%dd) : &js_lite(\%dd);
		$dd{'jscode'} =~ s/\/\*.*\*\/|\t//g;
		$dd{'jscode'} =~ s/ {2,}/ /g;
		$dd{'jscode'} =~ s/\n{2,}/\n/g;
		$dd{'outframe'} = &skin_frame(\%dd);
		$dd{'css'} = &skin_css();
		($dd{'title'} = $INI{'title'}) =~ s/<.*>//g;
		$output = &skin_oneman_frame(\%dd);
		&output_http_header('text/html', $INI{'code'});  ## or 'application/xhtml+xml'
	}
	print &char_convert($output, $INI{'code'}, $INI{'internal_code'});
	return 1;
}


##------------------------------------------
## Output HTTP header
##------------------------------------------
sub output_http_header{
	if(!$GLOBAL{'flag'}{'http_head'}){
		my($con_type, $code) = @_;
		$code = $GLOBAL{'charcode'}{$code} ? $GLOBAL{'charcode'}{$code} : $code;

		print "Pragma: no-cache\n";
		print "Cache-Control: no-cache\n";
		print $GLOBAL{'set_cook'};
		print "Content-type: $con_type; charset=$code\n";
		if($INI{'gzip'} && $ENV{'HTTP_ACCEPT_ENCODING'} =~ /gzip/ && $INI{'gzip_pass'} ne ''){
			print $ENV{'HTTP_ACCEPT_ENCODING'} =~ /x-gzip/ ? "Content-encoding: x-gzip\n\n" : "Content-encoding: gzip\n\n";
			open(STDOUT, "| $INI{'gzip_pass'} -1 -c");
		}
		else{print "\n";}
		$GLOBAL{'flag'}{'http_head'} = $| = 1;
	}
	return 1;
}


##------------------------------------------
## HTML header of internal inline-frame
##------------------------------------------
sub head{
	if(!$GLOBAL{'flag'}{'html_head'}){
		my %dd;
		$dd{'page_id'} = shift;
		$dd{'code'} = $GLOBAL{'charcode'}{$INI{'icode'}} ? $GLOBAL{'charcode'}{$INI{'icode'}} : $INI{'icode'};
		$dd{'bbs_id'} = "$GLOBAL{'bbs_id'}js";
		$dd{'visibility'} = $GLOBAL{'js_full_mode'} && $COOK{'jsmode'} ? 'hidden' : 'visible';
		$dd{'css'} = &skin_css2(\%dd);
		($dd{'title'} = $INI{'title'}) =~ s/<\w.*>//g;

		&output_http_header('text/html', $INI{'icode'});  ## or 'application/xhtml+xml'
		$GLOBAL{'flag'}{'html_head'} = 1;
		return &skin_head(\%dd);
	}
	else{return undef;}
}


##------------------------------------------
## News
##------------------------------------------
sub news{
	my $num = shift;
	my($line, %dd, $date, $type);

	open(LOGR, "$INI{'log_file'}") or &error((&skin_message())[1]);
	foreach(1..$num){
		$dd{'num'} = $_;  $line = <LOGR>;
		if($line eq ''){last;}
		($dd{'name'}, $date, $dd{'color'}, $dd{'com'}, undef, $type) = split(/\t/, $line);

		if($date =~ /\D/){$dd{'date'} = $date;}
		else{$dd{'date'} = &get_date($date + $INI{'TZ'}, $INI{'date_format'});}

		if(!$GLOBAL{'disp_time'}){$dd{'date_s'} = '';}
		elsif($GLOBAL{'disp_time'} == 1 && $date !~ /\D/){
			$dd{'date_s'} = &get_date($date + $INI{'TZ'}, $INI{'date_simple_format'})
		}
		else{$dd{'date_s'} = $dd{'date'};}

		if(!$type){$dd{'news'} = !$GLOBAL{'news_sort'} ? &skin_line(\%dd).$dd{'news'} : $dd{'news'}.&skin_line(\%dd);}
		else{$dd{'news'} = !$GLOBAL{'news_sort'} ? &skin_line_sysmess(\%dd).$dd{'news'} : $dd{'news'}.&skin_line_sysmess(\%dd);}
	}
	close(LOGR);

	print &char_convert(&head($in{'mode'} eq 'log' ? 'log' : 'news').&skin_news(\%dd), $INI{'icode'}, $INI{'internal_code'});
	return 1;
}


##------------------------------------------
## Option form
##------------------------------------------
sub option{
	if(!$in{'action'}){
		my(%dd, %sc);
		my $i = 0;
		my @mkey = ('', 'Alt', 'Shift', 'Alt+Shift', 'Ctrl', 'Alt+Ctrl', 'Shift+Ctrl', 'Alt+Shift+Ctrl');
		my @sccode = (48..57, 65..90, 37..40);
		my @sckey = ('0'..'9', 'A'..'Z', '&larr;', '&uarr;', '&rarr;', '&darr;');

		foreach(@{$INI{'color'}}){
			($dd{'print'}, $dd{'value'}) = split(/:/);
			$dd{'color'} = $dd{'value'};
			$dd{'selected'} = $dd{'value'} eq $COOK{'color'} ? ' selected="selected"' : '';
			$dd{'color_list'} .= &skin_option_select(\%dd);
		}

		$dd{'display'}{'visitorlist_usable'} = $GLOBAL{'visitorlist_usable'} ? 'block' : 'none';
		$dd{'display'}{'news_sort_usable'} = $INI{'news_sort_change_able'} ? 'block' : 'none';
		$dd{'display'}{'disp_time_usable'} = $INI{'disp_time_change_able'} ? 'block' : 'none';
		$dd{'display'}{'indv_usable'} = $INI{'individually_cookie_change_able'} ? 'block' : 'none';

		if($COOK{'stealth'} && $GLOBAL{'visitorlist_usable'}){$dd{'stealth_checked'} = ' checked="checked"';}
		if($COOK{'news_sort'}){$dd{'news_sort_checked'} = ' checked="checked"';}
		if($COOK{'disp_time'}){$dd{'disp_time_checked'} = ' checked="checked"';}
		elsif($COOK{'jsmode'}){$dd{'disp_simple_time_disable'} = ' disabled="disabled"';}
		if($COOK{'disp_time'} == 1){$dd{'disp_simple_time_checked'} = ' checked="checked"';}
		if($COOK{'indv'}){$dd{'indv_checked'} = ' checked="checked"';}

		if($GLOBAL{'js_full_mode'}){
			$dd{'display'}{'js_full_mode'} = 'block';
			if(!$COOK{'jsmode'}){$dd{'jsmode_checked'} = ' checked="checked"';}
			foreach(split(/:/, $COOK{'sckeydata'})){
				$sc{'m'}[$i] = substr($_, 0, 1);
				$sc{'k'}[$i] = substr($_, 1);
				$i++;
			}
			foreach $i(0..11){
				foreach(0..7){
					$dd{'value'} = $_;
					$dd{'print'} = $mkey[$_];
					$dd{'color'} = '000000';
					$dd{'selected'} = $dd{'value'} eq $sc{'m'}[$i] ? ' selected="selected"' : '';
					$dd{'mkey_list'}[$i] .= &skin_option_select(\%dd);
				}
				foreach(0..$#sccode){
					$dd{'value'} = $sccode[$_];
					$dd{'print'} = $sckey[$_];
					$dd{'color'} = '000000';
					$dd{'selected'} = $dd{'value'} eq $sc{'k'}[$i] ? ' selected="selected"' : '';
					$dd{'sckey_list'}[$i] .= &skin_option_select(\%dd);
				}
			}
		}
		else{$dd{'display'}{'js_full_mode'} = 'none';}
		print &char_convert(&head('option').&skin_option(\%dd), $INI{'icode'}, $INI{'internal_code'});
	}
	else{
		my @sclist = ('focus', 'mini', 'close', 'left', 'up', 'right', 'down', 'big', 'small', 'reset', 'news', 'vlist');
		my $sckeydata = '';

		if($ENV{'REQUEST_METHOD'} ne 'POST'){&error((&skin_message())[2]);}
		if(length(&remove_xss($in{'name_itext'}, 1)) > $INI{'len_name'}){&error((&skin_message())[3]);}
		if(!$in{'sc_default'}){
			foreach(@sclist){$sckeydata .= $in{"sc_m_$_"}.$in{"sc_k_$_"}.':';}
			chop $sckeydata;
		}

		$GLOBAL{'set_cook'} = &set_cook(
			$in{'name_itext'},
			$in{'color'},
			!$in{'stealth'}   ? 0 : 1,
			$in{'jsmode'}     ? 0 : 1,
			$sckeydata,
			!$in{'news_sort'} ? 0 : 1,
			!$in{'disp_time'} ? 0 : $in{'disp_simple_time'} ? 1 : 2,
			!$in{'indv'}      ? 0 : 1
		);

		if((!$in{'stealth'} && $COOK{'stealth'}) || ($in{'name_itext'} && !$COOK{'name'})){
			&modify_visitor('add', $COOK{'id'}, $in{'name_itext'});
		}
		elsif(($in{'stealth'} && !$COOK{'stealth'}) || (!$in{'name_itext'} && $COOK{'name'})){
			&modify_visitor('remove', $COOK{'id'});
		}
		elsif(!$in{'stealth'} && !$COOK{'stealth'}){
			&modify_visitor('modify', $COOK{'id'}, $in{'name_itext'});
		}

		&news($INI{'top_news'});
	}
	return 1;
}


##------------------------------------------
## Help
##------------------------------------------
sub help{
	my(%dd, %sckey);
	my $i = 0;
	my @mkey = ('', 'Alt + ', 'Shift + ', 'Alt + Shift + ', 'Ctrl + ', 'Alt + Ctrl + ', 'Shift + Ctrl + ', 'Alt + Shift + Ctrl + ');
	my @sccode = (48..57, 65..90, 37..40);
	my @sckey = ('0'..'9', 'A'..'Z', '&larr;', '&uarr;', '&rarr;', '&darr;');

	$dd{'name'} = $COOK{'name'} eq '' ? $INI{'no_name_frame'} : $COOK{'name'};
	if(length($dd{'name'}) > $INI{'len_p_name'}){$dd{'name'} = substr($dd{'name'}, 0, $INI{'len_p_name'} - 2).'...';}
	$dd{'autoreload_news'} = $INI{'realtime_reload'} && $GLOBAL{'ajax_usable'} ? 'block' : 'none';
	$dd{'display'}{'visitorlist_usable'} = $INI{'disp_visitor'} && $GLOBAL{'ajax_usable'} ? 'block' : 'none';
	$dd{'display'}{'visitorlist_reload_time'} = $INI{'visitorlist_reload_time'} && $GLOBAL{'visitorlist_usable'} ? 'block' : 'none';
	$dd{'display'}{'js_full_mode'} = $GLOBAL{'js_full_mode'} ? 'block' : 'none';
	foreach(0..$#sccode){$sckey{$sccode[$_]} = $sckey[$_];}
	foreach(split(/:/, $COOK{'sckeydata'})){$dd{'sc'}[$i] = $mkey[substr($_, 0, 1)].$sckey{substr($_, 1)};  $i++;}

	print &char_convert(&head('help').&skin_help(\%dd), $INI{'icode'}, $INI{'internal_code'});
	return 1;
}


##------------------------------------------
## Writing log routine
##------------------------------------------
sub regist{
	my($name, $color, $com, $type, $set_time) = @_;

	if($com ne ''){
		my($id, @news, $news, $i);
		$id = $COOK{'id'} eq '' ? 'nothing_id' : $COOK{'id'};

		if(!$type){
			if($ENV{'REQUEST_METHOD'} ne "POST"){
				&error((&skin_message())[2]);
			}
			if($INI{'interval'} && -e "$INI{'tmp_dir'}/$id.tmp" && (stat("$INI{'tmp_dir'}/$id.tmp"))[9] > time - $INI{'interval'}){
				&error((&skin_message())[4]);
			}
			if($INI{'deny_only_ascii'} && $com !~ /[\x80-\xff]/){
				&error((&skin_message())[17]);
			}
			if($INI{'deny_url'} && $com =~ m{(?:https?|shttp|ftp)://[\w\/\.\%\~\!\$\&\-\:\;\=\@]+}){
				&error((&skin_message())[18]);
			}
			if($INI{'deny_a_tag'} && $com =~ m{\&lt;a.*\&gt;|\&lt;/a\&gt;}){
				&error((&skin_message())[19]);
			}
			if(length($com) > $INI{'len_com'}){
				&error((&skin_message())[5]);
			}
			if($INI{'deny_no_name'} && $name eq ''){
				&error((&skin_message())[20]);
			}
			if(length($name) > $INI{'len_name'}){
				&error((&skin_message())[3]);
			}
		}

		$set_time or $set_time = time;
		$name eq '' and $name = $INI{'no_name'};
		$INI{'autolink'} and $com = &autolink($com);
		$news[0] = "$name\t$set_time\t$color\t$com\t$ENV{'REMOTE_ADDR'}\t$type\t\n";

		&lock();
		open(LOGR, "$INI{'log_file'}") or &error((&skin_message())[1]);
		for($i=1; $i<$INI{'log_news'}; $i++){$news = <LOGR>;  push(@news, $news);}
		close(LOGR);
		open(LOGW, "> $INI{'log_file'}") or &error((&skin_message())[6]);
		print LOGW @news;
		close(LOGW);

		if($INI{'realtime_reload'}){
			open(STAMP, "> $INI{'tmp_dir'}/$INI{'log_timestamp_file'}") or &error((&skin_message())[12]);
			print STAMP time;
			close(STAMP);
		}
		&unlock();

		if($INI{'interval'} && !$type){
			open(ID, "> $INI{'tmp_dir'}/$id.tmp") or &error((&skin_message())[11]);
			close(ID);
		}
	}
	return $com eq '' ? 0 : 1;
}


##------------------------------------------
## Writing visitor list routine
##------------------------------------------
sub modify_visitor{
	my($action, $id, $name) = @_;
	my(%dd, $log_id, $log_name, $log_date, $stamp_flag, $add_flag, $new_log, $name_utf8, $head);
	if(!$GLOBAL{'visitorlist_usable'} || (!$COOK{'jsmode'} && $action ne 'remove')){return 0;}
	$name_utf8 = &char_convert($name, 'UTF-8', $INI{'internal_code'});

	open(MEMBER, "$INI{'tmp_dir'}/$INI{'visitorlist_filename'}");
	$head = <MEMBER>;
	while(<MEMBER>){
		chomp;
		($log_name, $log_id, $log_date) = split(/\t/);
		if($log_id eq $id){
			if($action eq 'add'){$log_date = time;  $add_flag = 1;}
			elsif($action eq 'remove'){
				$stamp_flag = 1;
				if($INI{'disp_inout'} && ($COOK{'name'} || $log_name)){
					$dd{'name'} = $COOK{'name'} ne '' ?
					              $COOK{'name'} : &char_convert($log_name, $INI{'internal_code'}, 'UTF-8');
					&regist($INI{'system_mess_name'}, $INI{'color_out'}, (&skin_message(\%dd))[16], 1);
				}
				next;
			}
			elsif($action eq 'modify'){
				if($log_name ne $name_utf8){$stamp_flag = 1;}
				($log_name, $log_id, $log_date) = ($name_utf8, $id, time);
			}
			elsif($action eq 'renew'){$log_date = time;}
		}
		elsif($INI{'visitor_timeout'} < time - $log_date){
			$stamp_flag = 1;
			if($INI{'disp_inout'} && $log_name){
				$dd{'name'} = &char_convert($log_name, $INI{'internal_code'}, 'UTF-8');
				&regist($INI{'system_mess_name'}, $INI{'color_out'}, (&skin_message(\%dd))[16], 1, $log_date + $INI{'visitor_timeout'});
			}
			next;
		}
		$new_log .= "$log_name\t$log_id\t$log_date\n";
	}
	if($action eq 'add' && !$add_flag){
		$new_log .= "$name_utf8\t$id\t".time."\n";
		$stamp_flag = 1;
		if($INI{'disp_inout'} && $name){
			$dd{'name'} = $name;
			&regist($INI{'system_mess_name'}, $INI{'color_in'}, (&skin_message(\%dd))[15], 1);
		}
	}
	close(MEMBER);

	if($action eq 'clean' && !$stamp_flag){return 0;}
	&lock();
	open(MEMBER, "> $INI{'tmp_dir'}/$INI{'visitorlist_filename'}");
	print MEMBER "$GLOBAL{'product_name'}_VisitorList\n".$new_log;
	close(MEMBER);
	if($INI{'visitorlist_reload_time'} && $stamp_flag){
		open(STAMP, "> $INI{'tmp_dir'}/$INI{'visitorlist_timestamp_file'}");
		print STAMP time;
		close(STAMP);
	}
	&unlock();

	return 1;
}


##------------------------------------------
## Character-code conversion
##------------------------------------------
sub char_convert{
	my($value, $code, $incode) = @_;

	$code = $GLOBAL{'charcode'}{$code} ? $GLOBAL{'charcode'}{$code} : $code;
	$incode = $GLOBAL{'charcode'}{$incode} ? $GLOBAL{'charcode'}{$incode} : $incode;

	if($code eq $incode){return $value;}
	elsif($] >= 5.008 && $INI{'use_Encode'}){
		if($GLOBAL{'flag'}{'code'} != 1){
			eval "use lib qw($INI{'module_dir'});  use Encode;";
			$@ and &error($@, 'DEBUG');
			$GLOBAL{'flag'}{'code'} = 1;
		}
		Encode::from_to($value, $incode, $code);
	}
	elsif(
		$INI{'use_Jcode'} || $GLOBAL{'flag'}{'code'} == 2 ||
		($code ne 'Shift_JIS' && $code ne 'EUC-JP' && $code ne 'ISO-2022-JP') ||
		($incode ne 'Shift_JIS' && $incode ne 'EUC-JP' && $incode ne 'ISO-2022-JP')
	){
		if($GLOBAL{'flag'}{'code'} != 2){
			eval "use lib qw($INI{'module_dir'});  use Jcode;";
			$@ and &error($@, 'DEBUG');
			$GLOBAL{'flag'}{'code'} = 2;
		}
		my %charJcode = reverse %{$GLOBAL{'charcode'}};

		Jcode::convert(
			\$value,
			$charJcode{$code} ? $charJcode{$code} : $code,
			$charJcode{$incode} ? $charJcode{$incode} : $incode
		);
	}
	elsif(-e "$INI{'jcode'}"){
		do $INI{'jcode'} or &error($@ ? $@ : "jcode.pl: $!", 'DEBUG');
		$GLOBAL{'flag'}{'code'} = 3;
		my %charJcode = reverse %{$GLOBAL{'charcode'}};

		&jcode::convert(
			\$value,
			$charJcode{$code} ? $charJcode{$code} : $code,
			$charJcode{$incode} ? $charJcode{$incode} : $incode
		);
	}

	return $value;
}


##------------------------------------------
## Get date
##------------------------------------------
sub get_date{
	my($t, $format) = @_;
	$t or $t = time;
	$t =~ /\D/ and return $t;
	$format or $format = '_Y_-_M_-_D_T_H_:_N_:_S__T_';  ## W3C-DTF

	my($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime($t);
	my %date_format = (
		'_Y_' => sprintf("%04d", $year+1900),
		'_y_' => sprintf("%02d", substr($year, -1, 2)),
		'_L_' => ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec')[$mon],
		'_l_' => $INI{'month_name'}[$mon],
		'_M_' => sprintf("%02d", $mon+1),
		'_m_' => $mon+1,
		'_D_' => sprintf("%02d", $mday),
		'_d_' => $mday,
		'_W_' => ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat')[$wday],
		'_w_' => $INI{'week_name'}[$wday],
		'_H_' => sprintf("%02d", $hour),
		'_h_' => $hour,
		'_N_' => sprintf("%02d", $min),
		'_n_' => $min,
		'_S_' => sprintf("%02d", $sec),
		'_s_' => $sec,
		'_T_' => ($INI{'TZ'} >= 0 ? '+' : '-').sprintf("%02d", (gmtime(abs($INI{'TZ'})))[2]).':'.sprintf("%02d", (gmtime(abs($INI{'TZ'})))[1])
	);

	$format =~ s/(_[YyLlMmDdWwHhNnSsT]_)/$date_format{$1}/g;
	return $format;
}


##------------------------------------------
## Get browser-engine's name and version
##------------------------------------------
sub get_browser{
	my $version_edit = sub{
		my $browser_ver = shift;
		if($browser_ver =~ /^(\d+)\.(\d+)$/){
			$browser_ver = "$1.";
			foreach(split(//, $2)){$browser_ver .= sprintf("%03d", $_);}
		}
		elsif($browser_ver =~ /^(\d+)((?:\.\d+)+)$/){
			$browser_ver = "$1.";
			foreach(split(/\./, substr($2, 1))){$browser_ver .= sprintf("%03d", $_);}
		}
		return $browser_ver;
	};

	if($ENV{'HTTP_USER_AGENT'} =~ m|libwww(?:-perl/([\d\.]+))?|){
		return('LWP', $version_edit->($1), undef);
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ /[Gg]oogle(?:bot| CHTML)|msnbot|Slurp|Nutch|[Nn]aver/){
		return('BOT', undef, undef);
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ /DoCoMo|UP\.Browser|J-PHONE|Vodafone|MOT|KYOCERA|DDIPOCKET|PDXGW|ASTEL/){
		return('MOBILE', undef, undef);
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ m|Opera.([\d\.]+)([\w\d]*)|){
		return('Opera', $version_edit->($1), $2);      ## Opera
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ m|MSIE ([\d\.]+)([\w\d]*)|){
		return('IE', $version_edit->($1), $2);         ## Internet Explorer
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ m|iCab ([\d\.]+)([\w\d]*)|){
		return('iCab', $version_edit->($1), $2);       ## iCab
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ m|WebKit/([\d\.]+)([\w\d]*)|){
		return('WebKit', $version_edit->($1), $2);     ## Safari
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ /KHTML|Konqueror/){
		if($ENV{'HTTP_USER_AGENT'} =~ m|KHTML/([\d\.]+)([\w\d]*)|){
			return('KHTML', $version_edit->($1), $2);  ## KHTML
		}
		elsif($ENV{'HTTP_USER_AGENT'} =~ m|Konqueror/([\d\.]+)([\w\d]*)|){
			return('KHTML', $version_edit->($1), $2);  ## KHTML
		}
		else{
			return('KHTML', 0, undef);
		}
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ /Gecko/){
		if($ENV{'HTTP_USER_AGENT'} =~ /rv:([\d\.]+)([\w\d]*)/){
			return('Gecko', $version_edit->($1), $2);  ## Gecko (Netscape 6~, Mozilla, Firefox, etc)
		}
		else{
			return('Gecko', 0, undef);
		}
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ m|Lynx/([\d\.]+)([\w\d\.]*)|){
		return('Lynx', $version_edit->($1), $2);       ## Lynx
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ m|w3m/([\d\.]+)([\w\d]*)|){
		return('w3m', $version_edit->($1), $2);        ## w3m
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ m|Mozilla/([\d\.]+)([\w\d]*)|){
		return('Netscape', $version_edit->($1), $2);   ## Netscape 1~4
	}
	else{
		return('Unknown', undef, undef);
	}
}


##------------------------------------------
## Access Deny
##------------------------------------------
sub access_deny{
	my %dd;
	if($INI{'deny_proxy'}){
		$ENV{'REMOTE_ADDR'} =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/;
		if(join('.', unpack('C*', gethostbyname("$4.$3.$2.$1.niku.2ch.net"))) eq '127.0.0.2'){&error((&skin_message())[21]);}
	}

	if($INI{'deny_lwp'}        && $GLOBAL{'browser'} eq 'LWP'){&error((&skin_message())[0]);}
	if($INI{'deny_bot_access'} && $GLOBAL{'browser'} eq 'BOT'){&error((&skin_message())[0]);}

	foreach(@{$INI{'deny_ip'}}){
		if(!$_){next;}
		elsif($_ =~ /^(?:\d+|\*)(?:\.(?:\d+|\*)){0,3}$/){
			$_ =~ s/\*/\.\*/og;
			if($ENV{'REMOTE_ADDR'} =~ /$_/){&error((&skin_message())[0]);}
		}
		elsif($_ =~ /^(\d+(?:\.\d+){0,3})\/(\d+)$/){
			my $addr_edit = sub{return unpack("B$2", pack("C*", split(/\./, shift)));};
			if($addr_edit->($1) eq $addr_edit->($ENV{'REMOTE_ADDR'})){&error((&skin_message())[0]);}
		}
		elsif($_ =~ /^(\d+(?:\.\d+){0,3})\-(\d+(?:\.\d+){0,3})$/){
			my $addr_edit = sub{return sprintf("%3d%03d%03d%03d", split(/\./, shift));};
			if(
				$addr_edit->($1) <= $addr_edit->($ENV{'REMOTE_ADDR'}) &&
				$addr_edit->($2) >= $addr_edit->($ENV{'REMOTE_ADDR'})
			){
				&error((&skin_message())[0]);
			}
		}
	}
	return 1;
}


##------------------------------------------
## Auto Link
##------------------------------------------
sub autolink{
	my $value = shift;
	my $auto_link_f = sub{
		my($url, $mark, $anchor, $result) = @_;
		my %dd;
		if($url =~ /$INI{'url_filter'}/io){
			$dd{'url'} = "$url";
			($result = (&skin_message(\%dd))[13].$mark.$anchor) =~ s/[\t\n\r]//g;
		}
		elsif($mark){
			$dd{'url'} = "$url$mark$anchor";
			($result = &skin_autolink(\%dd)) =~ s/[\t\n\r]//g;
		}
		else{
			$dd{'url'} = "$url";
			($result = &skin_autolink(\%dd).$anchor) =~ s/[\t\n\r]//g;
		}
		return $result;
	};
	$value =~ s{((?:https?|shttp|ftp)://[\w\/\.\%\~\!\$\&\-\:\;\=\@]+)([#\?]?)([^ \s\@\<]*)}{$auto_link_f->($1, $2, $3)}eg;
	return $value;
}


##------------------------------------------
## File Lock
##------------------------------------------
sub lock{
	my $retry = 3;
	my $lock_type = $INI{'lock_type'};
	if($lock_type == 3){$lock_type = eval{symlink('', '');} ne '' ? 1 : 2;}

	if(
		-e "$INI{'tmp_dir'}/$INI{'lock_filename'}" &&
		(stat("$INI{'tmp_dir'}/$INI{'lock_filename'}"))[9] < time - 60
	){
		&unlock($lock_type);
	}

	if($lock_type == 1){
		while(!eval{symlink('.', "$INI{'tmp_dir'}/$INI{'lock_filename'}");}){
			if(--$retry <= 0){&error((&skin_message())[7]);}
			sleep(1);
		}
	}
	elsif($lock_type == 2){
		while(!mkdir("$INI{'tmp_dir'}/$INI{'lock_filename'}", 0705)){
			if(--$retry <= 0){&error((&skin_message())[7]);}
			sleep(1);
		}
	}

	$GLOBAL{'flag'}{'lock'} =$GLOBAL{'flag'}{'lockt'}= $lock_type;
	return $lock_type;
}


##------------------------------------------
## Remove File Lock
##------------------------------------------
sub unlock{
	$GLOBAL{'flag'}{'lock'} or $GLOBAL{'flag'}{'lock'} = shift;
	if($GLOBAL{'flag'}{'lock'}){
		if($GLOBAL{'flag'}{'lock'} == 1){unlink("$INI{'tmp_dir'}/$INI{'lock_filename'}");}
		elsif($GLOBAL{'flag'}{'lock'} == 2){rmdir("$INI{'tmp_dir'}/$INI{'lock_filename'}");}
		$GLOBAL{'flag'}{'lock'} = 0;
		return 1;
	}
	else{return 0;}
}


##------------------------------------------
## Get Cookie
##------------------------------------------
sub get_cook{
	my($key, $val, %ck);
	foreach(split(/;/, $ENV{'HTTP_COOKIE'})){
		($key, $val) = split(/=/);
		$key =~ s/\s//g;
		exists $ck{$key} or $ck{$key} = $val;
	}
	foreach(
		split(
			/<::>/,
			$ck{"RCSBBS3$GLOBAL{'bbs_id'}"} ne '' ? $ck{"RCSBBS3$GLOBAL{'bbs_id'}"} : $ck{'RCSBBS3'}
		)
	){
		($key, $val) = split(/<>/);
		$val =~ tr/+/ /;
		$val =~ s/%([\da-fA-F]{2})/chr hex($1)/ge;
		$val = &remove_xss($val);
		$val =~ s/[\t\n\r]//g;
		$COOK{$key} = $val;
	}

	if($COOK{'id'} =~ /\W/){$COOK{'id'} = '';}
	if($COOK{'color'} eq '' || $COOK{'color'} =~ /\W/){
		$COOK{'color'} = $INI{'color'}[0];
		$COOK{'color'} =~ s/^.*:(.*)$/$1/;
	}
	if($COOK{'stealth'} ne '0' && $COOK{'stealth'} ne '1'){$COOK{'stealth'} = '0';}
	if($COOK{'jsmode'} eq '' || $COOK{'jsmode'} =~ /\W/){$COOK{'jsmode'} = '1';}
	if($COOK{'sckeydata'} eq '' || $COOK{'sckeydata'} =~ /[^\d\:]/){
		$COOK{'sckeydata'} = $INI{'default_sckeydata'};
	}
	if($COOK{'news_sort'} ne '0' && $COOK{'news_sort'} ne '1'){
		$COOK{'news_sort'} = $INI{'news_sort'};
	}
	if($COOK{'disp_time'} ne '0' && $COOK{'disp_time'} ne '1' && $COOK{'disp_time'} ne '2'){
		$COOK{'disp_time'} = $INI{'disp_time'};
	}
	if((!$ck{"RCSBBS3$GLOBAL{'bbs_id'}"} && !$ck{"RCSBBS3"}) || $COOK{'indv'} eq ''){
		$COOK{'indv'} = $INI{'individually_cookie'};
	}

	$GLOBAL{'news_sort'} = ($INI{'news_sort_change_able'} && $COOK{'news_sort'}) ||
	                       (!$INI{'news_sort_change_able'} && $INI{'news_sort'}) ? 1 : 0;

	$GLOBAL{'disp_time'} = $INI{'disp_time_change_able'} && $COOK{'disp_time'} ?
	                       $COOK{'disp_time'} : !$INI{'disp_time_change_able'} && $INI{'disp_time'} ?
						   $INI{'disp_time'} : 0;

	$GLOBAL{'individually_cookie'} = ($INI{'individually_cookie_change_able'} && $COOK{'indv'}) ||
	                                 (!$INI{'individually_cookie_change_able'} && $INI{'individually_cookie'}) ? 1 : 0;
	return 1;
}


##------------------------------------------
## Cookie Register
##------------------------------------------
sub set_cook{
	my($name, $color, $stealth, $jsmode, $sckeydata, $news_sort, $disp_time, $indv, $set_cook) = @_;
	my $gmt = &get_date(time + 180*24*60*60, '_W_,_D_-_L_-_Y_ _H_:_N_:_S_ GMT');

	$name =~ s/([^\w ])/uc sprintf("%%%02x", ord($1))/eg;
	$name =~ tr/ /+/;
	if($COOK{'id'} eq ''){
		srand;
		foreach(1..20){$COOK{'id'} .= ('0'..'9', 'a'..'z', 'A'..'Z')[int(rand(62))];}
	}

	$GLOBAL{'individually_cookie'} = ($INI{'individually_cookie_change_able'} && $indv) ||
	                                 (!$INI{'individually_cookie_change_able'} && $INI{'individually_cookie'}) ? 1 : 0;

	if($GLOBAL{'individually_cookie'}){
		$set_cook .=
			qq|Set-Cookie: RCSBBS3$GLOBAL{'bbs_id'}=name<>$name<::>color<>$color<::>id<>$COOK{'id'}<::>|.
			qq|stealth<>$stealth<::>jsmode<>$jsmode<::>sckeydata<>$sckeydata<::>|.
			qq|news_sort<>$news_sort<::>disp_time<>$disp_time<::>indv<>$indv; expires=$gmt;\n|;
	}
	else{
		$set_cook .=
			qq|Set-Cookie: RCSBBS3=name<>$name<::>color<>$color<::>id<>$COOK{'id'}<::>|.
			qq|stealth<>$stealth<::>jsmode<>$jsmode<::>sckeydata<>$sckeydata<::>|.
			qq|news_sort<>$news_sort<::>disp_time<>$disp_time<::>indv<>$indv; expires=$gmt;\n|;
		if($COOK{'indv'}){
			$set_cook .= qq|Set-Cookie: RCSBBS3$GLOBAL{'bbs_id'}=; expires=Tue, 01-May-2007 00:00:00 GMT;\n|;
		}
	}

	$COOK{'news_sort'} = $news_sort;
	$COOK{'disp_time'} = $disp_time;

	$GLOBAL{'news_sort'} = ($INI{'news_sort_change_able'} && $COOK{'news_sort'}) ||
	                       (!$INI{'news_sort_change_able'} && $INI{'news_sort'}) ? 1 : 0;

	$GLOBAL{'disp_time'} = $INI{'disp_time_change_able'} && $COOK{'disp_time'} ?
	                       $COOK{'disp_time'} : !$INI{'disp_time_change_able'} && $INI{'disp_time'} ?
						   $INI{'disp_time'} : 0;

	return $set_cook;
}


##------------------------------------------
## Remove/Decode XSS
##------------------------------------------
sub remove_xss{
	my($value, $decode_flag) = @_;
	my %xss = ('<'=>'&lt;', '>'=>'&gt;', '('=>'&#40;', ')'=>'&#41;', '"'=>'&quot;');
	if($decode_flag){%xss = reverse %xss;}
	(my $pattern = join("|", keys(%xss))) =~ s/([\(\)])/\\$1/g;
	$value =~ s/($pattern)/$xss{$1}/g;
	return $value;
}


##------------------------------------------
## Error routine
##------------------------------------------
sub error{
	my(%dd, $code, $lang, $debug);
	($dd{'error_mess'}, $debug) = @_;

	if($debug){
		$dd{'error_mess'} =~ s/&/&amp;/g;
		$dd{'error_mess'} =~ &remove_xss($dd{'error_mess'});
	$dd{'error_mess'} =~ s/\n/<br \/>/g;}
	&unlock();

	if(
		($ENV{'CONTENT_LENGTH'} > 0 || $ENV{'QUERY_STRING'}) &&
		$ENV{'QUERY_STRING'} ne 'oneman' && $GLOBAL{'flag'}{'skin_load'} && !$debug
	){
		print &char_convert(&head('error').&skin_error(\%dd), $INI{'icode'}, $INI{'internal_code'});
	}
	elsif($INI{'oneman_mode'} || $ENV{'CONTENT_LENGTH'} > 0 || $ENV{'QUERY_STRING'}){
		if($GLOBAL{'flag'}{'skin_load'} && !$debug){
			$code = $GLOBAL{'charcode'}{$INI{'internal_code'}} ?
			        $GLOBAL{'charcode'}{$INI{'internal_code'}} : $INI{'internal_code'};
			$lang = $INI{'language'};
		}
		else{$code = 'UTF-8';  $lang = 'en';}

		if(!$GLOBAL{'flag'}{'http_head'}){print "Content-type: text/html; charset=$code\n\n";}
		print qq|<?xml version="1.0" encoding="$code"?>\n|.
			qq|<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">\n|.
			qq|<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="$lang">\n|.
			qq|<head><title>$GLOBAL{'product_name'}(id: $GLOBAL{'bbs_id'}): ERROR!!</title></head>\n|.
			qq|<body><p>$GLOBAL{'product_name'}(id: $GLOBAL{'bbs_id'}): ERROR!!</p><p>$dd{'error_mess'}</p></body></html>\n|;
	}
	else{
		if($GLOBAL{'flag'}{'skin_load'} && !$debug){
			$dd{'error_mess'} = &char_convert($dd{'error_mess'}, $INI{'code'}, $INI{'internal_code'});
			$code = $GLOBAL{'charcode'}{$INI{'code'}} ? $GLOBAL{'charcode'}{$INI{'code'}} : $INI{'code'};
		}
		else{$code = 'UTF-8';}
		$dd{'error_mess'} =~ s/(\\|')/\\$1/g;

		if(!$GLOBAL{'flag'}{'http_head'}){print "Content-type: image/png; charset=$code\n\n";}
		print "document.write('<p>$GLOBAL{'product_name'}(id: $GLOBAL{'bbs_id'}): ERROR!!<br />$dd{'error_mess'}</p>');";
	}
	&ex_exit();
}


##------------------------------------------
## Administrator mode
##------------------------------------------
sub admin{
	my($num, $news, %dd, $date, $type, @f_list);

	if($in{'admin_pass'} && $ENV{'REQUEST_METHOD'} ne "POST"){&error((&skin_message())[2]);}
	elsif($in{'admin_pass'} && $INI{'admin_pass'} eq $in{'admin_pass'}){
		if($in{'action'} eq 'del_view' || $in{'menu_submit_del'}){  ## Delete form
			open(LOGR, "$INI{'log_file'}") || &admin_error((&skin_message())[1]);
			while(<LOGR>){
				$dd{'num'}++;
				($dd{'name'}, $date, $dd{'color'}, $dd{'com'}, $dd{'ip'}, $type) = split(/\t/);

				if($date =~ /\D/){$dd{'date'} = $date;}
				else{$dd{'date'} = &get_date($date + $INI{'TZ'}, $INI{'date_format'});}

				if(!$GLOBAL{'disp_time'}){$dd{'date_s'} = '';}
				elsif($GLOBAL{'disp_time'} == 1 && $date !~ /\D/){
					$dd{'date_s'} = &get_date($date + $INI{'TZ'}, $INI{'date_simple_format'})
				}
				else{$dd{'date_s'} = $dd{'date'};}

				if(!$type){
					$dd{'news'} = !$GLOBAL{'news_sort'} ?
					              &skin_admin_del_line(\%dd).$dd{'news'} : $dd{'news'}.&skin_admin_del_line(\%dd);
				}
				else{
					$dd{'news'} = !$GLOBAL{'news_sort'} ?
					              &skin_admin_del_line_sysmess(\%dd).$dd{'news'} : $dd{'news'}.&skin_admin_del_line_sysmess(\%dd);
				}
			}
			close(LOGR);
			print &char_convert(&head('admindel').&skin_admin_del_view(\%dd), $INI{'icode'}, $INI{'internal_code'});
		}
		elsif($in{'action'} eq 'del'){  ## Delete
			if(!$in{'del_num_list'}){&admin_error((&skin_message())[9]);}

			&lock();
			open(LOGR, "$INI{'log_file'}") or &admin_error((&skin_message())[1]);
			LOGREAD: while(<LOGR>){
				$num++;
				foreach(@{$in{'del_num_list'}}){if($num == $_){$dd{'del_num'}++;  next LOGREAD;}}
				$news .= $_;
			}
			close(LOGR);

			open(LOGW, "> $INI{'log_file'}") or &admin_error((&skin_message())[6]);
			print LOGW $news;
			close(LOGW);
			&unlock();

			$dd{'mess'} = (&skin_message(\%dd))[8];
			print &char_convert(&head('admindelfin').&skin_admin_del_fin(\%dd), $INI{'icode'}, $INI{'internal_code'});
		}
		elsif($in{'action'} eq 'admin_write_form' or $in{'menu_submit_write'}){  ## Administrator's comment form
			print &char_convert(&head('adminwrite').&skin_admin_write_form(\%dd), $INI{'icode'}, $INI{'internal_code'});
		}
		elsif($in{'action'} eq 'admin_write'){  ## Administrator's comment writing
			if($in{'admincom_itext'} ne ''){
				&regist($INI{'admin_name'}, $INI{'admin_color'}, $in{'admincom_itext'}, 1);
				print &char_convert(&head('adminwritefin').&skin_admin_write_fin(\%dd), $INI{'icode'}, $INI{'internal_code'});
			}
			else{&admin_error((&skin_message(\%dd))[30]);}
		}
		elsif($in{'action'} eq 'admin_backup_form' or $in{'menu_submit_backup'}){  ## Backup control form
			opendir(TMPDIR, "$INI{'tmp_dir'}") or &admin_error((&skin_message())[28]);
			foreach(grep /\.backup$/, readdir(TMPDIR)){push(@f_list, (stat("$INI{'tmp_dir'}/$_"))[9]."<>$_");}
			closedir(TMPDIR);

			foreach(reverse(sort @f_list)){
				($dd{'time'}, $dd{'value'}) = split(/<>/, $_);
				$dd{'value'} =~ s/\.backup$//;
				$dd{'time'} = &get_date($dd{'time'} + $INI{'TZ'}, $INI{'date_format'});
				$dd{'file_list'} .= &skin_admin_backup_form_select(\%dd);
			}
			print &char_convert(&head('adminbackup').&skin_admin_backup_form(\%dd), $INI{'icode'}, $INI{'internal_code'});
		}
		elsif($in{'action'} eq 'admin_backup_make'){  ## Make backup-file
			if($in{'f_name'} =~ /\W/){&admin_error((&skin_message())[22]);}
			if(-e "$INI{'tmp_dir'}/$in{'f_name'}.backup"){&admin_error((&skin_message())[31]);}
			if($in{'f_name'} eq ''){$in{'f_name'} = &get_date(time + $INI{'TZ'}, '_Y__M__D__H__N__S_');}

			&lock();
			open(LOGR, "$INI{'log_file'}") or &admin_error((&skin_message())[1]);
			open(BAKW, "> $INI{'tmp_dir'}/$in{'f_name'}.backup") or &admin_error((&skin_message())[23]);
			while(<LOGR>){print BAKW $_;}
			close(BAKW);
			close(LOGR);
			&unlock();

			$dd{'mess'} = (&skin_message())[24];
			print &char_convert(&head('adminbackupfin').&skin_admin_backup_fin(\%dd), $INI{'icode'}, $INI{'internal_code'});
		}
		elsif($in{'action'} eq 'admin_backup_restore'){  ## Log-file restore
			if($in{'f_name'} eq ''){&admin_error((&skin_message())[29]);}

			&lock();
			open(BAKR, "$INI{'tmp_dir'}/$in{'f_name'}.backup") or &admin_error((&skin_message())[25]);
			open(LOGW, "> $INI{'log_file'}") or &admin_error((&skin_message())[6]);
			while(<BAKR>){print LOGW $_;}
			close(LOGW);
			close(BAKR);
			&unlock();

			$dd{'mess'} = (&skin_message())[26];
			print &char_convert(&head('adminbackupfin').&skin_admin_backup_fin(\%dd), $INI{'icode'}, $INI{'internal_code'});
		}
		elsif($in{'action'} eq 'admin_backup_del'){  ## Delete backup-file
			if($in{'f_name_list'} eq ''){&admin_error((&skin_message())[29]);}
			foreach(@{$in{'f_name_list'}}){unlink "$INI{'tmp_dir'}/$_.backup" and $dd{'del_num'}++;}
			$dd{'mess'} = (&skin_message(\%dd))[27];
			print &char_convert(&head('adminbackupfin').&skin_admin_backup_fin(\%dd), $INI{'icode'}, $INI{'internal_code'});
		}
		else{print &char_convert(&head('login').&skin_login(), $INI{'icode'}, $INI{'internal_code'});}
	}
	elsif($in{'admin_pass'} && $INI{'admin_pass'} ne $in{'admin_pass'}){&error((&skin_message())[10]);}
	else{print &char_convert(&head('login').&skin_login(), $INI{'icode'}, $INI{'internal_code'});}
	return 1;
}


##------------------------------------------
## Administrator error
##------------------------------------------
sub admin_error{
	my %dd;
	$dd{'mess'} = shift;
	&unlock();
	print &char_convert(&head('adminerror').&skin_admin_error(\%dd), $INI{'icode'}, $INI{'internal_code'});
	&ex_exit();
}


##------------------------------------------
## Exit routine
##------------------------------------------
sub ex_exit{
	if($^O ne 'MSWin32'){eval{alarm 0};}
	exit(0);
}


1;
